diff -pruN 7.1.2-2/debian/changelog 7.1.2-4/debian/changelog
--- 7.1.2-2/debian/changelog	2020-10-14 12:56:51.000000000 +0000
+++ 7.1.2-4/debian/changelog	2020-12-09 16:47:44.000000000 +0000
@@ -1,3 +1,19 @@
+cctools (7.1.2-4) unstable; urgency=medium
+
+  * Switch to B-D on python3-examples. Closes: #976851
+  * Standards-Version: 4.5.1; no changes required
+  * Update Hurd patch
+  * Update python-paths.patch
+  * Use libjsonparser-dev rather than bundled json.c. Closes: #958254
+
+ -- Alastair McKinstry <mckinstry@debian.org>  Wed, 09 Dec 2020 16:47:44 +0000
+
+cctools (7.1.2-3) unstable; urgency=medium
+
+  * Disable parrot; doesn't work on amd64, i386. Closes: #972232
+
+ -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Oct 2020 13:07:03 +0100
+
 cctools (7.1.2-2) unstable; urgency=medium
 
   * Fix FTBFS with python3.9. Closes: #972191
diff -pruN 7.1.2-2/debian/control 7.1.2-4/debian/control
--- 7.1.2-2/debian/control	2020-10-14 12:56:51.000000000 +0000
+++ 7.1.2-4/debian/control	2020-12-09 16:47:44.000000000 +0000
@@ -5,7 +5,7 @@ Maintainer: Alastair McKinstry <mckinstr
 Build-Depends: debhelper-compat (= 13), 
   dh-sequence-python3,
   python3-all-dev, 
-  python3.8-examples,
+  python3-examples,
   libglobus-common-dev,
   default-libmysqlclient-dev,
   libfuse-dev,
@@ -18,10 +18,11 @@ Build-Depends: debhelper-compat (= 13),
   libglobus-gss-assist-dev, net-tools, doxygen,
   libreadline6-dev | libreadline-dev, 
   libncurses5-dev | libncurses-dev, 
+  libjsonparser-dev,
   swig,
   m4, 
   mpi-default-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://ccl.cse.nd.edu/software/
 Vcs-Browser: https://salsa.debian.org:/neurodebian-team/cctools.git
 Vcs-Git: https://salsa.debian.org:/neurodebian-team/cctools.git -b debian/latest
diff -pruN 7.1.2-2/debian/patches/hurd 7.1.2-4/debian/patches/hurd
--- 7.1.2-2/debian/patches/hurd	2020-10-14 12:56:51.000000000 +0000
+++ 7.1.2-4/debian/patches/hurd	2020-12-09 16:47:44.000000000 +0000
@@ -1,6 +1,6 @@
 Description: Changes needed for Hurd-i1386 support
 Author: Alastair McKinstry <mckinstry@debian.org>
-Last-Updated: 2018-06-28
+Last-Updated: 2020-12-08
 Forwarded: no
 
 Index: cctools-7.1.2/work_queue/src/work_queue.c
@@ -197,3 +197,612 @@ Index: cctools-7.1.2/dttools/src/auth_ti
  #include <sys/stat.h>
  
  #include <assert.h>
+Index: cctools-7.1.2/parrot/src/pfs_service_ext.cc
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/pfs_service_ext.cc
++++ cctools-7.1.2/parrot/src/pfs_service_ext.cc
+@@ -16,6 +16,10 @@ See the file COPYING for details.
+ #include <sys/types.h>
+ #include <dirent.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ #include "pfs_service.h"
+ 
+ extern "C" {
+Index: cctools-7.1.2/parrot/test/TR_parrot_mmap.sh
+===================================================================
+--- cctools-7.1.2.orig/parrot/test/TR_parrot_mmap.sh
++++ cctools-7.1.2/parrot/test/TR_parrot_mmap.sh
+@@ -21,6 +21,10 @@ prepare()
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ void dumpmaps (void)
+ {
+ 	char buf[65536] = "";
+Index: cctools-7.1.2/batch_job/src/batch_job_internal.h
+===================================================================
+--- cctools-7.1.2.orig/batch_job/src/batch_job_internal.h
++++ cctools-7.1.2/batch_job/src/batch_job_internal.h
+@@ -19,6 +19,10 @@ See the file COPYING for details.
+ #include "hash_table.h"
+ #include "itable.h"
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ #define BATCH_JOB_LINE_MAX 8192
+ 
+ struct batch_queue_module {
+Index: cctools-7.1.2/batch_job/src/work_queue_factory.c
+===================================================================
+--- cctools-7.1.2.orig/batch_job/src/work_queue_factory.c
++++ cctools-7.1.2/batch_job/src/work_queue_factory.c
+@@ -46,6 +46,10 @@ See the file COPYING for details.
+ #include <unistd.h>
+ #include <signal.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #define CCTOOLS_RUNOS_PATH "/afs/crc.nd.edu/group/ccl/software/runos/runos.py"
+ #define CCTOOLS_VC3_BUILDER_PATH "/afs/crc.nd.edu/group/ccl/software/vc3-builder-src/vc3-builder"
+ 
+Index: cctools-7.1.2/chirp/src/chirp_group.h
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_group.h
++++ cctools-7.1.2/chirp/src/chirp_group.h
+@@ -10,6 +10,10 @@ See the file COPYING for details.
+ 
+ #include <limits.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define MATH_MAX 1024
++#endif
++
+ extern char chirp_group_base_url[PATH_MAX];
+ extern int  chirp_group_cache_time;
+ 
+Index: cctools-7.1.2/chirp/src/chirp_acl.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_acl.c
++++ cctools-7.1.2/chirp/src/chirp_acl.c
+@@ -31,6 +31,10 @@ See the file COPYING for details.
+ #include <fcntl.h>
+ #include <dirent.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ const char *chirp_super_user = "";
+ 
+ static int read_only_mode = 0;
+Index: cctools-7.1.2/chirp/src/confuga_adm.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/confuga_adm.c
++++ cctools-7.1.2/chirp/src/confuga_adm.c
+@@ -16,6 +16,10 @@ See the file COPYING for details.
+ #include <limits.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ static int process (confuga *C, int argc, char *argv[])
+ {
+ 	int rc;
+Index: cctools-7.1.2/chirp/src/chirp_job.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_job.c
++++ cctools-7.1.2/chirp/src/chirp_job.c
+@@ -40,6 +40,10 @@
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #define IMMUTABLE_JOB_INSERT(T) \
+ 		"CREATE TRIGGER " T "ImmutableJobI BEFORE INSERT ON " T " FOR EACH ROW" \
+ 		"    BEGIN" \
+Index: cctools-7.1.2/chirp/src/chirp_server.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_server.c
++++ cctools-7.1.2/chirp/src/chirp_server.c
+@@ -75,6 +75,10 @@
+ 
+ #define GC_TIMEOUT  (86400)
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ /* The maximum chunk of memory the server will allocate to handle I/O */
+ #define MAX_BUFFER_SIZE (16*1024*1024)
+ 
+Index: cctools-7.1.2/chirp/src/confuga.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/confuga.c
++++ cctools-7.1.2/chirp/src/confuga.c
+@@ -52,6 +52,10 @@ See the file COPYING for details.
+ #include <string.h>
+ #include <time.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ #ifdef CCTOOLS_OPSYS_DARWIN
+ 	/* Cygwin does not have 64-bit I/O, while FreeBSD/Darwin has it by default. */
+ #	define stat64 stat
+Index: cctools-7.1.2/chirp/src/confuga_gc.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/confuga_gc.c
++++ cctools-7.1.2/chirp/src/confuga_gc.c
+@@ -13,6 +13,10 @@
+ 
+ #include <assert.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #ifndef O_CLOEXEC
+ #	define O_CLOEXEC 0
+ #endif
+Index: cctools-7.1.2/chirp/src/confuga_namespace.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/confuga_namespace.c
++++ cctools-7.1.2/chirp/src/confuga_namespace.c
+@@ -32,6 +32,10 @@ See the file COPYING for details.
+ #include <stdio.h>
+ #include <stdlib.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #ifdef CCTOOLS_OPSYS_DARWIN
+ 	/* Cygwin does not have 64-bit I/O, while FreeBSD/Darwin has it by default. */
+ #	define stat64 stat
+Index: cctools-7.1.2/dttools/src/elfheader.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/elfheader.c
++++ cctools-7.1.2/dttools/src/elfheader.c
+@@ -31,6 +31,10 @@ typedef int64_t  Elf32_Sxword;
+ typedef uint64_t Elf64_Xword;
+ typedef int64_t  Elf64_Sxword;
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ #define EI_NIDENT 16
+ #define ELFMAG "\x7f" "ELF"
+ 
+@@ -47,6 +51,10 @@ typedef int64_t  Elf64_Sxword;
+ #define ELFCLASS32 1
+ #define ELFCLASS64 2
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ typedef struct {
+ 	unsigned char e_ident[EI_NIDENT];
+ 	Elf32_Half e_type;
+Index: cctools-7.1.2/dttools/src/elfheader.h
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/elfheader.h
++++ cctools-7.1.2/dttools/src/elfheader.h
+@@ -9,6 +9,10 @@ See the file COPYING for details.
+ 
+ #include <limits.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ /** Get the interpreter (PT_INTERP) for the executable.
+  *
+  * @param fd The open file descriptor to the executable.
+Index: cctools-7.1.2/chirp/src/chirp_fs_local_scheduler.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_fs_local_scheduler.c
++++ cctools-7.1.2/chirp/src/chirp_fs_local_scheduler.c
+@@ -56,6 +56,10 @@
+ #include <stdint.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ #ifndef O_CLOEXEC
+ #	define O_CLOEXEC 0
+ #endif
+Index: cctools-7.1.2/chirp/src/confuga_node.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/confuga_node.c
++++ cctools-7.1.2/chirp/src/confuga_node.c
+@@ -28,6 +28,10 @@ See the file COPYING for details.
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ #define STOPTIME_SHORT  (time(NULL)+5)
+ #define TICKET_DURATION (12*60*60)
+ 
+Index: cctools-7.1.2/chirp/src/chirp_filesystem.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_filesystem.c
++++ cctools-7.1.2/chirp/src/chirp_filesystem.c
+@@ -34,6 +34,10 @@ See the file COPYING for details.
+ #include <stdio.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #define CHIRP_FILESYSTEM_BUFFER  65536
+ 
+ struct chirp_filesystem *cfs = NULL;
+Index: cctools-7.1.2/chirp/src/chirp_group.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_group.c
++++ cctools-7.1.2/chirp/src/chirp_group.c
+@@ -17,6 +17,9 @@ See the file COPYING for details.
+ #include <errno.h>
+ #include <sys/stat.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
+ 
+ extern char chirp_transient_path[PATH_MAX];
+ 
+Index: cctools-7.1.2/dttools/src/memfdexe.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/memfdexe.c
++++ cctools-7.1.2/dttools/src/memfdexe.c
+@@ -14,6 +14,10 @@
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ int memfdexe (const char *name, const char *extradir)
+ {
+ 	int fd;
+Index: cctools-7.1.2/dttools/src/path_disk_size_info.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/path_disk_size_info.c
++++ cctools-7.1.2/dttools/src/path_disk_size_info.c
+@@ -18,6 +18,10 @@ See the file COPYING for details.
+ #include "stringtools.h"
+ #include "xxmalloc.h"
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ struct DIR_with_name {
+ 	DIR *dir;
+ 	char *name;
+Index: cctools-7.1.2/dttools/src/clean_dir.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/clean_dir.c
++++ cctools-7.1.2/dttools/src/clean_dir.c
+@@ -15,6 +15,10 @@ See the file COPYING for details.
+ #include <stdio.h>
+ #include <unistd.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ int clean_dir(const char *dirname, const char *delete_pattern)
+ {
+ 	char subdir[PATH_MAX];
+Index: cctools-7.1.2/dttools/src/compat-at.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/compat-at.c
++++ cctools-7.1.2/dttools/src/compat-at.c
+@@ -22,6 +22,10 @@
+ #include <stdio.h>
+ #include <stdlib.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ static int getfullpath (int dirfd, const char *path, char fullpath[PATH_MAX])
+ {
+ 	char dirpath[PATH_MAX] = ".";
+Index: cctools-7.1.2/dttools/src/copy_stream.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/copy_stream.c
++++ cctools-7.1.2/dttools/src/copy_stream.c
+@@ -23,6 +23,10 @@ See the file COPYING for details.
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #define COPY_BUFFER_SIZE (1<<16)
+ 
+ int64_t copy_fd_to_stream(int fd, FILE *output)
+Index: cctools-7.1.2/dttools/src/copy_tree.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/copy_tree.c
++++ cctools-7.1.2/dttools/src/copy_tree.c
+@@ -22,6 +22,10 @@
+ #include "path.h"
+ #include "xxmalloc.h"
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ static mode_t default_dirmode = S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH;
+ 
+ int copy_dir_real(const char *source, const char *target);
+Index: cctools-7.1.2/dttools/src/debug.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/debug.c
++++ cctools-7.1.2/dttools/src/debug.c
+@@ -23,6 +23,10 @@ See the file COPYING for details.
+ 
+ #include <stdio.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ extern void debug_stderr_write (int64_t flags, const char *str);
+ extern void debug_stdout_write (int64_t flags, const char *str);
+ 
+Index: cctools-7.1.2/dttools/src/debug_file.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/debug_file.c
++++ cctools-7.1.2/dttools/src/debug_file.c
+@@ -21,6 +21,10 @@ See the file COPYING for details.
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ static int file_fd = -1;
+ static struct stat file_stat;
+ static char file_path[PATH_MAX];
+Index: cctools-7.1.2/dttools/src/file_cache.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/file_cache.c
++++ cctools-7.1.2/dttools/src/file_cache.c
+@@ -24,6 +24,10 @@ See the file COPYING for details.
+ #include <signal.h>
+ #include <time.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ /* Cygwin does not have 64-bit I/O, while Darwin has it by default. */
+ 
+ #ifdef CCTOOLS_OPSYS_DARWIN
+Index: cctools-7.1.2/dttools/src/jx_database.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/jx_database.c
++++ cctools-7.1.2/dttools/src/jx_database.c
+@@ -22,6 +22,10 @@ See the file COPYING for details.
+ #include <sys/types.h>
+ #include <stdarg.h>
+ 
++#ifndef PATH_MAX // Hurd
++#define PATH_MAX 1024
++#endif
++
+ struct jx_database {
+ 	struct hash_table *table;
+ 	const char *logdir;
+Index: cctools-7.1.2/dttools/src/mkdir_recursive.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/mkdir_recursive.c
++++ cctools-7.1.2/dttools/src/mkdir_recursive.c
+@@ -20,6 +20,10 @@ See the file COPYING for details.
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ int mkdirat_recursive (int fd, const char *path, mode_t mode)
+ {
+ 	int rc;
+Index: cctools-7.1.2/dttools/src/path.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/path.c
++++ cctools-7.1.2/dttools/src/path.c
+@@ -24,6 +24,10 @@
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ void path_absolute (const char *src, char *dest, int exist)
+ {
+ 	struct stat buf;
+Index: cctools-7.1.2/dttools/src/rmonitor_poll.c
+===================================================================
+--- cctools-7.1.2.orig/dttools/src/rmonitor_poll.c
++++ cctools-7.1.2/dttools/src/rmonitor_poll.c
+@@ -26,6 +26,10 @@ See the file COPYING for details.
+ #include "path_disk_size_info.h"
+ #include "load_average.h"
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ /***
+  * Helper functions
+ ***/
+Index: cctools-7.1.2/dttools/test/TR_path_dirname.sh
+===================================================================
+--- cctools-7.1.2.orig/dttools/test/TR_path_dirname.sh
++++ cctools-7.1.2/dttools/test/TR_path_dirname.sh
+@@ -12,6 +12,10 @@ prepare()
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ void test (const char *in, const char *expected)
+ {
+ 	char out[PATH_MAX];
+Index: cctools-7.1.2/parrot/src/irods_reli.cc
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/irods_reli.cc
++++ cctools-7.1.2/parrot/src/irods_reli.cc
+@@ -38,6 +38,10 @@ extern "C" {
+ #include "stringtools.h"
+ }
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #include <string>
+ 
+ extern int pfs_irods_debug_level;
+Index: cctools-7.1.2/parrot/src/parrot_package_create.c
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/parrot_package_create.c
++++ cctools-7.1.2/parrot/src/parrot_package_create.c
+@@ -17,6 +17,9 @@
+ #include <time.h>
+ #include <limits.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
+ 
+ #include "copy_stream.h"
+ #include "debug.h"
+Index: cctools-7.1.2/parrot/src/pfs_channel.c
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/pfs_channel.c
++++ cctools-7.1.2/parrot/src/pfs_channel.c
+@@ -22,6 +22,10 @@ See the file COPYING for details.
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ struct entry {
+ 	char *name;
+ 	pfs_size_t start;
+Index: cctools-7.1.2/parrot/src/pfs_dispatch64.cc
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/pfs_dispatch64.cc
++++ cctools-7.1.2/parrot/src/pfs_dispatch64.cc
+@@ -68,6 +68,10 @@ extern "C" {
+ #include <string.h>
+ #include <time.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #ifndef EFD_CLOEXEC
+ #	define EFD_CLOEXEC 02000000
+ #endif
+Index: cctools-7.1.2/parrot/src/pfs_dispatch.cc
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/pfs_dispatch.cc
++++ cctools-7.1.2/parrot/src/pfs_dispatch.cc
+@@ -59,6 +59,10 @@ extern "C" {
+ #include <string.h>
+ #include <time.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #ifndef EFD_CLOEXEC
+ #	define EFD_CLOEXEC 02000000
+ #endif
+Index: cctools-7.1.2/parrot/src/pfs_main.cc
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/pfs_main.cc
++++ cctools-7.1.2/parrot/src/pfs_main.cc
+@@ -75,6 +75,10 @@ extern "C" {
+ 
+ #include <vector>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #define SIG_ISSTOP(s) (s == SIGTTIN || s == SIGTTOU || s == SIGSTOP || s == SIGTSTP)
+ 
+ FILE *namelist_file;
+Index: cctools-7.1.2/parrot/src/pfs_process.cc
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/pfs_process.cc
++++ cctools-7.1.2/parrot/src/pfs_process.cc
+@@ -31,6 +31,10 @@ extern "C" {
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ pfs_pid_mode_t pfs_pid_mode = PFS_PID_MODE_NORMAL;
+ 
+ int emulated_pid = 12345;
+Index: cctools-7.1.2/parrot/src/pfs_table.cc
+===================================================================
+--- cctools-7.1.2.orig/parrot/src/pfs_table.cc
++++ cctools-7.1.2/parrot/src/pfs_table.cc
+@@ -63,6 +63,10 @@ extern "C" {
+ #include <stdlib.h>
+ #include <string.h>
+ 
++#ifndef PATH_MAX
++#define PATH_MAX 1024
++#endif
++
+ #ifndef O_CLOEXEC
+ #	define O_CLOEXEC 02000000
+ #endif
diff -pruN 7.1.2-2/debian/patches/python-paths.patch 7.1.2-4/debian/patches/python-paths.patch
--- 7.1.2-2/debian/patches/python-paths.patch	2020-10-14 12:56:51.000000000 +0000
+++ 7.1.2-4/debian/patches/python-paths.patch	2020-12-09 16:47:44.000000000 +0000
@@ -1,50 +1,96 @@
-Index: cctools-7.0.22/umbrella/src/umbrella.py
+Description: Use python3 paths explicitly.
+ Note: python2->python3 changs in python3.patch
+Author: Alastair McKinstry <mckintry@debian.org>
+Last-Updated: 2020-12-09
+Forwarded: no
+
+Index: cctools-7.1.2/umbrella/src/umbrella.py
 ===================================================================
---- cctools-7.0.22.orig/umbrella/src/umbrella.py
-+++ cctools-7.0.22/umbrella/src/umbrella.py
+--- cctools-7.1.2.orig/umbrella/src/umbrella.py
++++ cctools-7.1.2/umbrella/src/umbrella.py
 @@ -1,4 +1,4 @@
 -#! /usr/bin/env python
 +#!/usr/bin/python3
  
  # All the vanilla python package dependencies of Umbrella can be satisfied by a standard installation of Python 2.{6,7} or Python 3.
  """
-Index: cctools-7.0.22/makeflow/src/mf_mesos_executor
+Index: cctools-7.1.2/makeflow/src/mf_mesos_executor
 ===================================================================
---- cctools-7.0.22.orig/makeflow/src/mf_mesos_executor
-+++ cctools-7.0.22/makeflow/src/mf_mesos_executor
+--- cctools-7.1.2.orig/makeflow/src/mf_mesos_executor
++++ cctools-7.1.2/makeflow/src/mf_mesos_executor
 @@ -1,4 +1,4 @@
 -#!/usr/bin/env python
 +#!/usr/bin/python3
  
  # Copyright (c) 2016- The University of Notre Dame.
  # This software is distributed under the GNU General Public License.
-Index: cctools-7.0.22/makeflow/src/mf_mesos_scheduler
+Index: cctools-7.1.2/makeflow/src/mf_mesos_scheduler
 ===================================================================
---- cctools-7.0.22.orig/makeflow/src/mf_mesos_scheduler
-+++ cctools-7.0.22/makeflow/src/mf_mesos_scheduler
+--- cctools-7.1.2.orig/makeflow/src/mf_mesos_scheduler
++++ cctools-7.1.2/makeflow/src/mf_mesos_scheduler
 @@ -1,4 +1,4 @@
 -#!/usr/bin/env python
 +#!/usr/bin/python3
  
  # Copyright (c) 2016- The University of Notre Dame.
  # This software is distributed under the GNU General Public License.
-Index: cctools-7.0.22/makeflow/src/makeflow_archive_query
+Index: cctools-7.1.2/makeflow/src/makeflow_archive_query
 ===================================================================
---- cctools-7.0.22.orig/makeflow/src/makeflow_archive_query
-+++ cctools-7.0.22/makeflow/src/makeflow_archive_query
+--- cctools-7.1.2.orig/makeflow/src/makeflow_archive_query
++++ cctools-7.1.2/makeflow/src/makeflow_archive_query
 @@ -1,4 +1,4 @@
 -#!/usr/bin/python
 +#!/usr/bin/python3
  
  import hashlib
  import os
-Index: cctools-7.0.22/makeflow/src/mf_mesos_setting
+Index: cctools-7.1.2/makeflow/src/mf_mesos_setting
 ===================================================================
---- cctools-7.0.22.orig/makeflow/src/mf_mesos_setting
-+++ cctools-7.0.22/makeflow/src/mf_mesos_setting
+--- cctools-7.1.2.orig/makeflow/src/mf_mesos_setting
++++ cctools-7.1.2/makeflow/src/mf_mesos_setting
 @@ -1,4 +1,4 @@
 -#!/usr/bin/env python
 +#!/usr/bin/python3
  
  # Copyright (c) 2016- The University of Notre Dame.
  # This software is distributed under the GNU General Public License.
+Index: cctools-7.1.2/apps/makeflow_blasr/makeflow_blasr
+===================================================================
+--- cctools-7.1.2.orig/apps/makeflow_blasr/makeflow_blasr
++++ cctools-7.1.2/apps/makeflow_blasr/makeflow_blasr
+@@ -1,4 +1,4 @@
+-#!/usr/bin/env python
++#!/usr/bin/python3
+ 
+ # Copyright (C) 2014- The University of Notre Dame
+ # This software is distributed under the GNU General Public License.
+Index: cctools-7.1.2/apps/makeflow_bwa/makeflow_bwa
+===================================================================
+--- cctools-7.1.2.orig/apps/makeflow_bwa/makeflow_bwa
++++ cctools-7.1.2/apps/makeflow_bwa/makeflow_bwa
+@@ -1,4 +1,4 @@
+-#!/usr/bin/env python
++#!/usr/bin/python3
+ #
+ #Copyright (C) 2013- The University of Notre Dame
+ #This software is distributed under the GNU General Public License.
+Index: cctools-7.1.2/makeflow/src/makeflow_ec2_cleanup
+===================================================================
+--- cctools-7.1.2.orig/makeflow/src/makeflow_ec2_cleanup
++++ cctools-7.1.2/makeflow/src/makeflow_ec2_cleanup
+@@ -1,4 +1,4 @@
+-#!/usr/bin/env python
++#!/usr/bin/python3
+ 
+ import json
+ import sys
+Index: cctools-7.1.2/makeflow/src/makeflow_ec2_setup
+===================================================================
+--- cctools-7.1.2.orig/makeflow/src/makeflow_ec2_setup
++++ cctools-7.1.2/makeflow/src/makeflow_ec2_setup
+@@ -1,4 +1,4 @@
+-#!/usr/bin/env python
++#!/usr/bin/python3
+ 
+ import json
+ import sys
diff -pruN 7.1.2-2/debian/patches/rm-json 7.1.2-4/debian/patches/rm-json
--- 7.1.2-2/debian/patches/rm-json	1970-01-01 00:00:00.000000000 +0000
+++ 7.1.2-4/debian/patches/rm-json	2020-12-09 16:47:44.000000000 +0000
@@ -0,0 +1,130 @@
+Description: Use Debian package libjsonparser rather than bundled json.c
+Author: Alastair McKinstry <mckinstry@debian.org>
+Last-Updated: 2020-12-08
+Forwarded: no
+
+Index: cctools-7.1.2/chirp/src/chirp_job.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_job.c
++++ cctools-7.1.2/chirp/src/chirp_job.c
+@@ -22,7 +22,7 @@
+ 
+ #include "buffer.h"
+ #include "debug.h"
+-#include "json.h"
++#include <json-parser/json.h>
+ #include "json_aux.h"
+ #include "macros.h"
+ #include "path.h"
+Index: cctools-7.1.2/chirp/src/chirp_job.h
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_job.h
++++ cctools-7.1.2/chirp/src/chirp_job.h
+@@ -7,7 +7,7 @@
+ #ifndef CHIRP_JOB_H
+ #define CHIRP_JOB_H
+ 
+-#include "json.h"
++#include <json-parser/json.h>
+ 
+ #include "chirp_types.h"
+ 
+Index: cctools-7.1.2/chirp/src/chirp_server.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/chirp_server.c
++++ cctools-7.1.2/chirp/src/chirp_server.c
+@@ -30,7 +30,7 @@
+ #include "getopt_aux.h"
+ #include "host_disk_info.h"
+ #include "host_memory_info.h"
+-#include "json.h"
++#include <json-parser/json.h>
+ #include "jx.h"
+ #include "jx_print.h"
+ #include "link.h"
+Index: cctools-7.1.2/chirp/src/confuga_job.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/confuga_job.c
++++ cctools-7.1.2/chirp/src/confuga_job.c
+@@ -7,7 +7,7 @@ See the file COPYING for details.
+ #include "confuga_fs.h"
+ 
+ #include "debug.h"
+-#include "json.h"
++#include <json-parser/json.h>
+ #include "json_aux.h"
+ 
+ #include "catch.h"
+Index: cctools-7.1.2/chirp/src/confuga_replica.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/confuga_replica.c
++++ cctools-7.1.2/chirp/src/confuga_replica.c
+@@ -13,7 +13,7 @@ See the file COPYING for details.
+ #include "catalog_query.h"
+ #include "catch.h"
+ #include "debug.h"
+-#include "json.h"
++#include <json-parser/json.h>
+ #include "json_aux.h"
+ #include "nvpair.h"
+ #include "sha1.h"
+Index: cctools-7.1.2/chirp/src/json_aux.c
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/json_aux.c
++++ cctools-7.1.2/chirp/src/json_aux.c
+@@ -1,6 +1,6 @@
+ #include "buffer.h"
+ #include "copy_stream.h"
+-#include "json.h"
++#include <json-parser/json.h>
+ #include "json_aux.h"
+ 
+ #include <assert.h>
+Index: cctools-7.1.2/chirp/src/json_aux.h
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/json_aux.h
++++ cctools-7.1.2/chirp/src/json_aux.h
+@@ -2,7 +2,7 @@
+ #define JSON_AUX_H
+ 
+ #include "buffer.h"
+-#include "json.h"
++#include <json-parser/json.h>
+ 
+ #define jistype(o,t) ((o)->type == (t))
+ 
+Index: cctools-7.1.2/chirp/src/Makefile
+===================================================================
+--- cctools-7.1.2.orig/chirp/src/Makefile
++++ cctools-7.1.2/chirp/src/Makefile
+@@ -7,7 +7,7 @@ include ../../rules.mk
+ LOCAL_CCFLAGS = -DSQLITE_DEFAULT_MMAP_SIZE=1073741824 -DSQLITE_TEMP_STORE=3 -DSQLITE_THREADSAFE=0 -fstack-protector-all
+ 
+ # Globus is needed by all executables via libdttools.a/auth_globus.o
+-LOCAL_LINKAGE = $(CCTOOLS_GLOBUS_LDFLAGS) -lsqlite3
++LOCAL_LINKAGE = $(CCTOOLS_GLOBUS_LDFLAGS) -lsqlite3 -ljsonparser
+ 
+ EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
+ LIBRARIES = libchirp.a libconfuga.a
+@@ -21,7 +21,7 @@ PROGRAMS_CONFUGA = confuga_adm
+ PUBLIC_HEADERS = chirp_global.h chirp_multi.h chirp_reli.h chirp_client.h chirp_stream.h chirp_protocol.h chirp_matrix.h chirp_types.h chirp_recursive.h confuga.h
+ SCRIPTS = chirp_audit_cluster chirp_server_hdfs
+ SOURCES_CONFUGA = confuga.c confuga_namespace.c confuga_replica.c confuga_node.c confuga_job.c confuga_file.c confuga_gc.c
+-SOURCES_LIBRARY = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c json.c json_aux.c
++SOURCES_LIBRARY = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c  json_aux.c
+ SOURCES_SERVER =  chirp_stats.c chirp_thirdput.c chirp_alloc.c chirp_audit.c chirp_acl.c chirp_group.c chirp_filesystem.c chirp_fs_hdfs.c chirp_fs_local.c chirp_fs_local_scheduler.c chirp_fs_chirp.c chirp_fs_confuga.c chirp_job.c chirp_sqlite.c
+ TARGETS = $(PROGRAMS) $(LIBRARIES)
+ 
+Index: cctools-7.1.2/configure
+===================================================================
+--- cctools-7.1.2.orig/configure
++++ cctools-7.1.2/configure
+@@ -1294,7 +1294,7 @@ if [ "$optstatic" = 1 ]
+ then
+ 	static_libraries="../../dttools/src/libdttools.a ${zlib_path}/lib/libz.a"
+ else
+-	external_libraries="${external_libraries} -lstdc++ -lpthread -lz -lc -lm"
++	external_libraries="${external_libraries} -lstdc++ -lpthread -lz -lc -lm -ljsonparser"
+ fi
+ 
+ if [ $BUILD_SYS = DARWIN ]
diff -pruN 7.1.2-2/debian/patches/series 7.1.2-4/debian/patches/series
--- 7.1.2-2/debian/patches/series	2020-10-14 12:56:51.000000000 +0000
+++ 7.1.2-4/debian/patches/series	2020-12-09 16:47:44.000000000 +0000
@@ -11,3 +11,4 @@ perl-path
 python3.patch
 ccflags.patch
 python3-path-use.patch
+rm-json
diff -pruN 7.1.2-2/debian/rules 7.1.2-4/debian/rules
--- 7.1.2-2/debian/rules	2020-10-14 12:56:51.000000000 +0000
+++ 7.1.2-4/debian/rules	2020-12-09 16:47:44.000000000 +0000
@@ -18,7 +18,8 @@ override_dh_auto_configure:
 		--with-krb5-path /usr --with-readline-path /usr \
 		--with-mpi-path /usr --with-fuse-path /usr --with-zlib-path /usr \
 		--with-python3-path /usr/bin/python3 \
-		--with-python2-path no 
+		--with-python2-path no \
+		--without-system-parrot
 
 override_dh_auto_test:
 	# disable the tests for now on upstream's request. they will be reenabled
